package bc_handleproto;

use bc_enc;
use bc_handleproto;
use bc_global;
use bc_modules;

use strict;
use Socket;

# **Protocol Handlers**

sub C2S_send {
  my $data = $_[0];
  my ($ipaddr, $portaddr, $r);
  $ipaddr   = inet_aton($bc_global::server);
  $portaddr = sockaddr_in($bc_global::port, $ipaddr);
  $r = defined(send($bc_global::socketfd, $data, 0, $portaddr)) || die 'send $server:'."$!";
  $bc_global::TotalPacketsSent += 1;
  return $r;
}

sub S2C_recv {
  my ($maxlen, $portaddr, $port, $ipaddr, $rmsg, @rpacket);
  $maxlen=520;
  $portaddr = recv($bc_global::socketfd, $rmsg, $maxlen, 0) or die "recv: $!";
  #($port, $ipaddr) = sockaddr_in($portaddr);
  #$host = gethostbyaddr($ipaddr, AF_INET);
  @rpacket = bc_enc::decrypt($rmsg);
  console_debug("Received: ".join(" ", bc_enc::tohex(@rpacket)));
  $bc_global::TotalPacketsRecv += 1;
  bc_modules::exec_interpreters(@rpacket);
  return @rpacket;
}

sub getTicks {
  my ($sec, $ms);
  $sec = time();
  $ms = $sec * 1000;
  return int($ms);
}

sub console_write {
  my $message = $_[0];

  if ($bc_global::chat == 1) {
    print "$message\n";
  }
}

sub console_debug {
  my $message = $_[0];

  if ($bc_global::debug == 1) {
    print "$message\n";
  }
}

sub undef_p {
  bc_modules::exec_interpreters("undef_p");
}

# Signal EOF
1;
